link-vmlinux.sh 5.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211
  1. #!/bin/sh
  2. #
  3. # link vmlinux
  4. #
  5. # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
  6. # $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
  7. # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8. # Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
  9. #
  10. # vmlinux
  11. # ^
  12. # |
  13. # +-< $(KBUILD_VMLINUX_INIT)
  14. # | +--< init/version.o + more
  15. # |
  16. # +--< $(KBUILD_VMLINUX_MAIN)
  17. # | +--< drivers/built-in.o mm/built-in.o + more
  18. # |
  19. # +-< ${kallsymso} (see description in KALLSYMS section)
  20. #
  21. # vmlinux version (uname -v) cannot be updated during normal
  22. # descending-into-subdirs phase since we do not yet know if we need to
  23. # update vmlinux.
  24. # Therefore this step is delayed until just before final link of vmlinux.
  25. #
  26. # System.map is generated to document addresses of all kernel symbols
  27. # Error out on error
  28. set -e
  29. # Nice output in kbuild format
  30. # Will be supressed by "make -s"
  31. info()
  32. {
  33. if [ "${quiet}" != "silent_" ]; then
  34. printf " %-7s %s\n" ${1} ${2}
  35. fi
  36. }
  37. # Link of vmlinux.o used for section mismatch analysis
  38. # ${1} output file
  39. modpost_link()
  40. {
  41. ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
  42. --start-group ${KBUILD_VMLINUX_MAIN} --end-group
  43. }
  44. # Link of vmlinux
  45. # ${1} - optional extra .o files
  46. # ${2} - output file
  47. vmlinux_link()
  48. {
  49. local lds="${objtree}/${KBUILD_LDS}"
  50. if [ "${SRCARCH}" != "um" ]; then
  51. ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
  52. -T ${lds} ${KBUILD_VMLINUX_INIT} \
  53. --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
  54. else
  55. ${CC} ${CFLAGS_vmlinux} -o ${2} \
  56. -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
  57. -Wl,--start-group \
  58. ${KBUILD_VMLINUX_MAIN} \
  59. -Wl,--end-group \
  60. -lutil ${1}
  61. rm -f linux
  62. fi
  63. }
  64. # Create ${2} .o file with all symbols from the ${1} object file
  65. kallsyms()
  66. {
  67. info KSYM ${2}
  68. local kallsymopt;
  69. if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
  70. kallsymopt=--all-symbols
  71. fi
  72. local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
  73. ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
  74. ${NM} -n ${1} | \
  75. scripts/kallsyms ${kallsymopt} | \
  76. ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
  77. }
  78. # Create map file with all symbols from ${1}
  79. # See mksymap for additional details
  80. mksysmap()
  81. {
  82. ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
  83. }
  84. # Delete output files in case of error
  85. trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
  86. cleanup()
  87. {
  88. rm -f .old_version
  89. rm -f .tmp_System.map
  90. rm -f .tmp_kallsyms*
  91. rm -f .tmp_version
  92. rm -f .tmp_vmlinux*
  93. rm -f System.map
  94. rm -f vmlinux
  95. rm -f vmlinux.o
  96. }
  97. #
  98. #
  99. # Use "make V=1" to debug this script
  100. case "${KBUILD_VERBOSE}" in
  101. *1*)
  102. set -x
  103. ;;
  104. esac
  105. if [ "$1" = "clean" ]; then
  106. cleanup
  107. exit 0
  108. fi
  109. # We need access to CONFIG_ symbols
  110. . ./.config
  111. #link vmlinux.o
  112. info LD vmlinux.o
  113. modpost_link vmlinux.o
  114. # modpost vmlinux.o to check for section mismatches
  115. ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
  116. # Update version
  117. info GEN .version
  118. if [ ! -r .version ]; then
  119. rm -f .version;
  120. echo 1 >.version;
  121. else
  122. mv .version .old_version;
  123. expr 0$(cat .old_version) + 1 >.version;
  124. fi;
  125. # final build of init/
  126. ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
  127. kallsymso=""
  128. kallsyms_vmlinux=""
  129. if [ -n "${CONFIG_KALLSYMS}" ]; then
  130. # kallsyms support
  131. # Generate section listing all symbols and add it into vmlinux
  132. # It's a three step process:
  133. # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
  134. # but __kallsyms is empty.
  135. # Running kallsyms on that gives us .tmp_kallsyms1.o with
  136. # the right size
  137. # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
  138. # the right size, but due to the added section, some
  139. # addresses have shifted.
  140. # From here, we generate a correct .tmp_kallsyms2.o
  141. # 2a) We may use an extra pass as this has been necessary to
  142. # woraround some alignment related bugs.
  143. # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
  144. # 3) The correct ${kallsymso} is linked into the final vmlinux.
  145. #
  146. # a) Verify that the System.map from vmlinux matches the map from
  147. # ${kallsymso}.
  148. kallsymso=.tmp_kallsyms2.o
  149. kallsyms_vmlinux=.tmp_vmlinux2
  150. # step 1
  151. vmlinux_link "" .tmp_vmlinux1
  152. kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
  153. # step 2
  154. vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
  155. kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
  156. # step 2a
  157. if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
  158. kallsymso=.tmp_kallsyms3.o
  159. kallsyms_vmlinux=.tmp_vmlinux3
  160. vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
  161. kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
  162. fi
  163. fi
  164. info LD vmlinux
  165. vmlinux_link "${kallsymso}" vmlinux
  166. info SYSMAP System.map
  167. mksysmap vmlinux System.map
  168. # step a (see comment above)
  169. if [ -n "${CONFIG_KALLSYMS}" ]; then
  170. mksysmap ${kallsyms_vmlinux} .tmp_System.map
  171. if ! cmp -s System.map .tmp_System.map; then
  172. echo Inconsistent kallsyms data
  173. echo echo Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
  174. cleanup
  175. exit 1
  176. fi
  177. fi
  178. # We made a new kernel - delete old version file
  179. rm -f .old_version